import React from 'react';
import { ControllerHof, Form, AnyState, ErrorsInline, SetOrDeleteErrorParams, SetValueParams, SetValuesParams, SetFieldStateParams, SetOrDeleteOuterErrorParams, FieldInitParams } from './ts';
import { DerivedFieldType } from './ts-derived-field-type';
type UseFormParamsWithFactory<Values extends object, Meta> = {
    form: Form<Values>;
    meta?: Meta;
    resetUnmount?: boolean;
};
type UseFormResultWithFactory<Values extends AnyState> = {
    controller: ControllerHof<any, DerivedFieldType<Values>>;
    c: ControllerHof<any, DerivedFieldType<Values>>;
    handleSubmit: (e: React.SyntheticEvent<HTMLFormElement>) => void;
    setMeta: (meta: any) => void;
    setValue: (params: SetValueParams) => void;
    setValues: (params: SetValuesParams<Values>) => void;
    setOrDeleteError: (params: SetOrDeleteErrorParams) => SetOrDeleteErrorParams;
    setFieldState: (params: SetFieldStateParams) => SetFieldStateParams;
    setOrDeleteOuterError: (params: SetOrDeleteOuterErrorParams) => SetOrDeleteOuterErrorParams;
    setOuterErrorsInlineState: (params: ErrorsInline) => ErrorsInline;
    validateForm: () => void;
    submit: (e: any) => void;
    reset: () => void;
    fieldInit: (params: FieldInitParams) => FieldInitParams;
};
declare const useForm: <Values extends AnyState, Meta>({ form, meta, resetUnmount, }: UseFormParamsWithFactory<Values, Meta>) => UseFormResultWithFactory<Values>;
export default useForm;
